package net.wanji.opt.servicev2.report.impl;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import net.wanji.opt.controllerv2.report.vo.CrossProblemVO;
import net.wanji.opt.dao.mapper.report.CrossProblemMapper;
import net.wanji.opt.servicev2.report.CrossProblemService;
import net.wanji.opt.vo2.report.*;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author fengyi
 * @since 2025-04-09
 */
@Service
@Slf4j
public class CrossProblemServiceImpl    implements CrossProblemService {
    @Autowired
    private CrossProblemMapper crossProblemMapper;
    @Override
    public List<CrossProblemTotalityResult> getCrossProblemList(String crossIds,String yearWeek , String yearWeekAfter) {
        List<String> crossIdList = null;
        if (ObjectUtil.isNotEmpty(crossIds)) {
            crossIdList = Arrays.stream(crossIds.split(","))
                    .map(String::trim) // 去除可能的空格
                    .filter(s -> !s.isEmpty()) // 过滤掉空字符串
                    .collect(Collectors.toList());
        }

        CrossProblemVO todayWeek1 = crossProblemMapper.selectCrossProblem(crossIdList,yearWeek);
        CrossProblemVO afterWeek1 = crossProblemMapper.selectCrossProblem(crossIdList,yearWeekAfter);
        List<CrossProblemTotalityResult> crossProblemTotalityResultList = new ArrayList<>();


        List<CrossProblemTotalityDataList> crossProblemTotalityDataList = new ArrayList<>();
        CrossProblemTotalityResult crossProblemTotalityResult = new CrossProblemTotalityResult();
        CrossProblemTotalityDataList crossProblemTotalityDataListVO = new CrossProblemTotalityDataList();
        CrossProblemTotalityDataList crossProblemTotalityDataListV1 = new CrossProblemTotalityDataList();
        if(todayWeek1 != null && afterWeek1 != null) {
            crossProblemTotalityDataListVO.setDataType("1");
            crossProblemTotalityDataListVO.setThisWeekEmptyPassNumber(todayWeek1.getEvenNumber701());
            crossProblemTotalityDataListVO.setLastWeekEmptyPassNumber(afterWeek1.getEvenNumber701());
            crossProblemTotalityDataListVO.setThisWeekCongestNumber(todayWeek1.getEvenNumber707());
            crossProblemTotalityDataListVO.setLastWeekCongestNumber(afterWeek1.getEvenNumber707());
            crossProblemTotalityDataListVO.setThisWeekOverFlowNumber(todayWeek1.getEvenNumber703());
            crossProblemTotalityDataListVO.setLastWeekOverFlowNumber(afterWeek1.getEvenNumber703());
            crossProblemTotalityDataListVO.setThisWeekUnbalanceNumber(todayWeek1.getEvenNumber702());
            crossProblemTotalityDataListVO.setLastWeekUnbalanceNumber(afterWeek1.getEvenNumber702());
            crossProblemTotalityDataList.add(crossProblemTotalityDataListVO);

            crossProblemTotalityDataListV1.setDataType("2");
            crossProblemTotalityDataListV1.setThisWeekEmptyPassNumber(todayWeek1.getEventTotalTime701());
            crossProblemTotalityDataListV1.setLastWeekEmptyPassNumber(afterWeek1.getEventTotalTime701());
            crossProblemTotalityDataListV1.setThisWeekCongestNumber(todayWeek1.getEventTotalTime707());
            crossProblemTotalityDataListV1.setLastWeekCongestNumber(afterWeek1.getEventTotalTime707());
            crossProblemTotalityDataListV1.setThisWeekOverFlowNumber(todayWeek1.getEventTotalTime703());
            crossProblemTotalityDataListV1.setLastWeekOverFlowNumber(afterWeek1.getEventTotalTime703());
            crossProblemTotalityDataListV1.setThisWeekUnbalanceNumber(todayWeek1.getEventTotalTime702());
            crossProblemTotalityDataListV1.setLastWeekUnbalanceNumber(afterWeek1.getEventTotalTime702());
            crossProblemTotalityDataList.add(crossProblemTotalityDataListV1);

            crossProblemTotalityResult.setDataList(crossProblemTotalityDataList);

            crossProblemTotalityResult.setWeekCongestCount(todayWeek1.getEvenNumber707());
            crossProblemTotalityResult.setWeekCongestDuration(todayWeek1.getEventTotalTime707());
            crossProblemTotalityResult.setWeekOverFlowCount(todayWeek1.getEvenNumber703());
            crossProblemTotalityResult.setWeekOverFlowDuration(todayWeek1.getEventTotalTime703());

            if (Integer.parseInt(todayWeek1.getEvenNumber707()) > Integer.parseInt(afterWeek1.getEvenNumber707())) {
                Double t = 0.0;
                if (Integer.parseInt(afterWeek1.getEvenNumber707()) == 0) {
                    t = (double) (Integer.parseInt(todayWeek1.getEvenNumber707()) - Integer.parseInt(afterWeek1.getEvenNumber707())) / 1;
                } else {
                    t = (double) (Integer.parseInt(todayWeek1.getEvenNumber707()) - Integer.parseInt(afterWeek1.getEvenNumber707())) / Integer.parseInt(afterWeek1.getEvenNumber707());
                }
                t = Math.round(t * 100 * 10.0) / 10.0;
                crossProblemTotalityResult.setWeekCongestCountCompare("增加" + t + "%");
                crossProblemTotalityResult.setWeekTotalitySituation("略有下降");

            } else if (Integer.parseInt(todayWeek1.getEvenNumber707()) == Integer.parseInt(afterWeek1.getEvenNumber707())) {
                crossProblemTotalityResult.setWeekCongestCountCompare("保持不变");
                crossProblemTotalityResult.setWeekTotalitySituation("保持不变");
            } else {
                Double t = (double) (Integer.parseInt(afterWeek1.getEvenNumber707()) - Integer.parseInt(todayWeek1.getEvenNumber707())) / Integer.parseInt(afterWeek1.getEvenNumber707());
                t = Math.round(t * 100 * 10.0) / 10.0;
                crossProblemTotalityResult.setWeekCongestCountCompare("减少" + t + "%");
                crossProblemTotalityResult.setWeekTotalitySituation("明显上升");
            }

            if (Double.parseDouble(todayWeek1.getEventTotalTime707()) > Double.parseDouble(afterWeek1.getEventTotalTime707())) {
                Double t = 0.0;
                if (Double.parseDouble(afterWeek1.getEventTotalTime707()) == 0) {
                    t = (double) (Double.parseDouble(todayWeek1.getEventTotalTime707()) - Double.parseDouble(afterWeek1.getEventTotalTime707())) / 1;
                } else {
                    t = (double) (Double.parseDouble(todayWeek1.getEventTotalTime707()) - Double.parseDouble(afterWeek1.getEventTotalTime707())) / Double.parseDouble(afterWeek1.getEventTotalTime707());
                }
                t = Math.round(t * 100 * 10.0) / 10.0;
                crossProblemTotalityResult.setWeekCongestDurationCompare("增加" + t + "%");

            } else if (Double.parseDouble(todayWeek1.getEventTotalTime707()) == Double.parseDouble(afterWeek1.getEventTotalTime707())) {
                crossProblemTotalityResult.setWeekCongestDurationCompare("保持不变");
            } else {
                Double t = (double) (Double.parseDouble(afterWeek1.getEventTotalTime707()) - Double.parseDouble(todayWeek1.getEventTotalTime707())) / Double.parseDouble(afterWeek1.getEventTotalTime707());
                t = Math.round(t * 100 * 10.0) / 10.0;
                crossProblemTotalityResult.setWeekCongestDurationCompare("减少" + t + "%");

            }

            if (Integer.parseInt(todayWeek1.getEvenNumber703()) > Integer.parseInt(afterWeek1.getEvenNumber703())) {
                Double t = 0.0;
                if (Integer.parseInt(afterWeek1.getEvenNumber703()) == 0) {
                    t = (double) (Integer.parseInt(todayWeek1.getEvenNumber703()) - Integer.parseInt(afterWeek1.getEvenNumber703())) / 1;
                } else {
                    t = (double) (Integer.parseInt(todayWeek1.getEvenNumber703()) - Integer.parseInt(afterWeek1.getEvenNumber703())) / Integer.parseInt(afterWeek1.getEvenNumber703());
                }
                t = Math.round(t * 100 * 10.0) / 10.0;
                crossProblemTotalityResult.setWeekOverFlowCountCompare("增加" + t + "%");

            } else if (Integer.parseInt(todayWeek1.getEvenNumber703()) == Integer.parseInt(afterWeek1.getEvenNumber703())) {
                crossProblemTotalityResult.setWeekOverFlowCountCompare("保持不变");
            } else {
                Double t = (double) (Integer.parseInt(afterWeek1.getEvenNumber703()) - Integer.parseInt(todayWeek1.getEvenNumber703())) / Integer.parseInt(afterWeek1.getEvenNumber703());
                t = Math.round(t * 100 * 10.0) / 10.0;
                crossProblemTotalityResult.setWeekOverFlowCountCompare("减少" + t + "%");

            }

            if (Double.parseDouble(todayWeek1.getEventTotalTime703()) > Double.parseDouble(afterWeek1.getEventTotalTime703())) {
                Double t = 0.0;
                if (Double.parseDouble(afterWeek1.getEventTotalTime703()) == 0) {
                    t = (double) (Double.parseDouble(todayWeek1.getEventTotalTime703()) - Double.parseDouble(afterWeek1.getEventTotalTime703())) / 1;
                } else {
                    t = (double) (Double.parseDouble(todayWeek1.getEventTotalTime703()) - Double.parseDouble(afterWeek1.getEventTotalTime703())) / Double.parseDouble(afterWeek1.getEventTotalTime703());
                }
                t = Math.round(t * 100 * 10.0) / 10.0;
                crossProblemTotalityResult.setWeekOverFlowDurationCompare("增加" + t + "%");

            } else if (Double.parseDouble(todayWeek1.getEventTotalTime703()) == Double.parseDouble(afterWeek1.getEventTotalTime703())) {
                crossProblemTotalityResult.setWeekOverFlowDurationCompare("保持不变");
            } else {
                Double t = (double) (Double.parseDouble(afterWeek1.getEventTotalTime703()) - Double.parseDouble(todayWeek1.getEventTotalTime703())) / Double.parseDouble(afterWeek1.getEventTotalTime703());
                t = Math.round(t * 100 * 10.0) / 10.0;
                crossProblemTotalityResult.setWeekOverFlowDurationCompare("减少" + t + "%");

            }

            crossProblemTotalityResultList.add(crossProblemTotalityResult);
        }
        return crossProblemTotalityResultList;
    }

    public CrossImportProblemResultResponseVO getCrossSeriousProblem(String crossIds,String yearWeek) {
        List<String> crossIdList = null;
        if (ObjectUtil.isNotEmpty(crossIds)) {
            crossIdList = Arrays.stream(crossIds.split(","))
                    .map(String::trim) // 去除可能的空格
                    .filter(s -> !s.isEmpty()) // 过滤掉空字符串
                    .collect(Collectors.toList());
        }
        CrossImportProblemResultResponseVO crossImportProblemResultResponseVO = new CrossImportProblemResultResponseVO();
        boolean isHaveData = false;
        List<CrossImportProblemDataVO> list1 = new ArrayList<>();
        List<CrossImportProblemDataVO> list2 = new ArrayList<>();
        List<CrossImportProblemDataForQuery> crossImportProblemData703 = crossProblemMapper.selectCrossProblemByType(crossIdList, yearWeek, "703");
        if (crossImportProblemData703.size() > 1){
            isHaveData = true;
            crossImportProblemResultResponseVO.setOverFlowCrossName(crossImportProblemData703.get(0).getCrossName() + "," + crossImportProblemData703.get(1).getCrossName());
            crossImportProblemResultResponseVO.setOverFlowDuration(crossImportProblemData703.get(1).getEventTotalTime());
        }else if(crossImportProblemData703.size() == 1) {
            isHaveData = true;
            crossImportProblemResultResponseVO.setOverFlowCrossName(crossImportProblemData703.get(0).getCrossName());
            crossImportProblemResultResponseVO.setOverFlowDuration(crossImportProblemData703.get(0).getEventTotalTime());
        }
        for(CrossImportProblemDataForQuery temp : crossImportProblemData703){
            CrossImportProblemDataVO crossImportProblemDataVO = new CrossImportProblemDataVO();
            CrossImportProblemDataForQuery  crossImportProblemDataForQuery703 = crossProblemMapper.selectCrossProblemWorkDayByType(temp.getCrossId(),yearWeek,"703");
            crossImportProblemDataVO.setDataType("1");
            crossImportProblemDataVO.setCrossName(crossImportProblemDataForQuery703.getCrossName());
            crossImportProblemDataVO.setDuration(crossImportProblemDataForQuery703.getEventTotalTime());
            crossImportProblemDataVO.setSeriousTimeSpan(crossImportProblemDataForQuery703.getSeriousTimeSpan());
            crossImportProblemDataVO.setSeriousTimeSpanDuration(crossImportProblemDataForQuery703.getSeriousDuration());
            crossImportProblemDataVO.setWorkDayAvgOverCount(crossImportProblemDataForQuery703.getWorkDayEventNumber());
            crossImportProblemDataVO.setWorkDayAvgOverDuration(crossImportProblemDataForQuery703.getWorkDayEventTotalTime());
            List<CrossImportProblemDetailVO> crossImportProblemDetailVOList = crossProblemMapper.selectCrossProblemSeriousDataByType(temp.getCrossId(),yearWeek,"703");
            crossImportProblemDataVO.setList(crossImportProblemDetailVOList);
            list1.add(crossImportProblemDataVO);
            isHaveData = true;
        }

        List<CrossImportProblemDataForQuery>  crossImportProblemData707 = crossProblemMapper.selectCrossProblemByType(crossIdList,yearWeek,"707");
        if(crossImportProblemData707.size() > 1) {
            isHaveData = true;
            crossImportProblemResultResponseVO.setCongestCrossName(crossImportProblemData707.get(0).getCrossName() + "," + crossImportProblemData707.get(1).getCrossName());
            crossImportProblemResultResponseVO.setCongestDuration(crossImportProblemData707.get(1).getEventTotalTime());
        }else if(crossImportProblemData707.size() == 1) {
            isHaveData = true;
            crossImportProblemResultResponseVO.setCongestCrossName(crossImportProblemData707.get(0).getCrossName());
            crossImportProblemResultResponseVO.setCongestDuration(crossImportProblemData707.get(0).getEventTotalTime());
        }
        for(CrossImportProblemDataForQuery temp : crossImportProblemData707){
            CrossImportProblemDataVO crossImportProblemDataVO = new CrossImportProblemDataVO();
            CrossImportProblemDataForQuery  crossImportProblemDataForQuery707 = crossProblemMapper.selectCrossProblemWorkDayByType(temp.getCrossId(),yearWeek,"707");
            crossImportProblemDataVO.setDataType("2");
            crossImportProblemDataVO.setCrossName(crossImportProblemDataForQuery707.getCrossName());
            crossImportProblemDataVO.setDuration(crossImportProblemDataForQuery707.getEventTotalTime());
            crossImportProblemDataVO.setSeriousTimeSpan(crossImportProblemDataForQuery707.getSeriousTimeSpan());
            crossImportProblemDataVO.setSeriousTimeSpanDuration(crossImportProblemDataForQuery707.getSeriousDuration());
            crossImportProblemDataVO.setWorkDayAvgOverCount(crossImportProblemDataForQuery707.getWorkDayEventNumber());
            crossImportProblemDataVO.setWorkDayAvgOverDuration(crossImportProblemDataForQuery707.getWorkDayEventTotalTime());
            List<CrossImportProblemDetailVO> crossImportProblemDetailVOList = crossProblemMapper.selectCrossProblemSeriousDataByType(temp.getCrossId(),yearWeek,"707");
            crossImportProblemDataVO.setList(crossImportProblemDetailVOList);
            list2.add(crossImportProblemDataVO);
            isHaveData = true;
        }
        crossImportProblemResultResponseVO.setOverFlowList(list1);
        crossImportProblemResultResponseVO.setCongestList(list2);
        if (isHaveData){
            return crossImportProblemResultResponseVO;
        }else {
            return  null;
        }
    }

}
